import { InternalStatus } from '../status';
interface NotifyOptions {
    id?: number;
}
declare type MessageHandler = (message: string, options?: NotifyOptions) => number;
export declare const notify: {
    success: MessageHandler;
    error: MessageHandler;
    loading: MessageHandler;
    custom: MessageHandler;
};
export declare const notifyPromise: <T extends unknown>(promise: Promise<T>, { loading, success, error, }: {
    loading: string;
    success: string | ((result: T) => string);
    error: string | ((reason: any) => string);
}) => Promise<T>;
export declare const useToasts: () => readonly [InternalStatus[], {
    onMouseEnter: () => void;
    onMouseLeave: () => void;
}];
export {};
